export declare type Value = any;
export declare type GetKey = (t: any) => string;
export declare type ArrayOptions = {
    orderSensitive: boolean;
    getKey?: GetKey;
    ignoreUndefinedKey?: boolean;
};
export declare type Option = {
    path: string | RegExp;
    ignore?: boolean;
    array?: ArrayOptions;
};
export declare type DiffResult = {
    type: DiffResultTypeEnum.Added;
    path: string;
    right: Value;
} | {
    type: DiffResultTypeEnum.Deleted;
    path: string;
    left: Value;
} | {
    type: DiffResultTypeEnum.Editted;
    path: string;
    left: Value;
    right: Value;
};
export declare enum DiffResultTypeEnum {
    Editted = "E",
    Added = "A",
    Deleted = "D"
}
export declare type Diff = (left: Value, right: Value, options?: Option[], currentPath?: string) => DiffResult[];
